﻿Public Class Form1
    Dim DeviceCount As Integer
    Dim DeviceIndex As Integer
    Dim TempDevString As String
    Dim BytesWritten As Byte
    Dim TempStringData As String
    Dim BytesRead As Integer
#Region "List Devices and Open"
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim i As Int16

        ' Get the number of device attached
        FT_Status = FT_GetNumberOfDevices(DeviceCount, vbNullChar, FT_LIST_NUMBER_ONLY)
        If FT_Status <> FT_OK Then
            Exit Sub
        End If
        ' Display device count on form
        If DeviceCount < 1 Then
            MsgBox("No Devices Detected")
            Me.Close()
        End If

        For i = 0 To DeviceCount - 1



            DeviceIndex = i
            ' Get serial number of device with index 0
            ' Allocate space for string variable
            TempDevString = Space(16)
            FT_Status = FT_GetDeviceString(DeviceIndex, TempDevString, FT_LIST_BY_INDEX Or FT_OPEN_BY_SERIAL_NUMBER)
            If FT_Status <> FT_OK Then
                Exit Sub
            End If
            FT_Serial_Number = Microsoft.VisualBasic.Left(TempDevString, InStr(1, TempDevString, vbNullChar) - 1)
            ' Display serial number on form
           

            ' Get description of device with index 0
            ' Allocate space for string variable
            TempDevString = Space(64)
            FT_Status = FT_GetDeviceString(DeviceIndex, TempDevString, FT_LIST_BY_INDEX Or FT_OPEN_BY_DESCRIPTION)
            If FT_Status <> FT_OK Then
                Exit Sub
            End If
            FT_Description = Microsoft.VisualBasic.Left(TempDevString, InStr(1, TempDevString, vbNullChar) - 1)
            ' Display serial number on form

            ComboBox1.Items.Add(i + 1 & " --- " & FT_Serial_Number & " --- " & FT_Description)
            ComboBox1.Text = ComboBox1.Items.Item(0)
            Label1.BackColor = Color.GreenYellow
        Next


        'FT_Status = FT_OpenByIndex(1, FT_Handle)
        'If FT_Status <> FT_OK Then
        '    MsgBox("Failed to open device.", , )
        '    Exit Sub
        'End If



        ''Open device by serial number
        'FT_Status = FT_OpenByDescription(FT_Description, 2, FT_Handle)
        'If FT_Status <> FT_OK Then
        '    MsgBox("Failed to open device.", , )
        '    Exit Sub
        'End If
        'FT_Status = FT_SetBaudRate(FT_Handle, FT_BAUD_230400)
        'If FT_Status <> FT_OK Then
        '    MsgBox("Failed to open device.", , )
        '    Exit Sub
        'End If

        '' Reset device
        'FT_Status = FT_ResetDevice(FT_Handle)
        'If FT_Status <> FT_OK Then
        '    MsgBox("Failed to open device.", , )
        '    Exit Sub
        'End If


        ' Purge buffers
        'FT_Status = FT_Purge(FT_Handle, FT_PURGE_RX Or FT_PURGE_TX)
        'If FT_Status <> FT_OK Then
        '    MsgBox("Failed to open device.", , )
        '    Exit Sub
        'End If

        'FT_Status = FT_SetBitMode(FT_Handle, &H0, FT_ASYNCHRONOUS_BIT_BANG)
        'If Not FT_Status = FT_OK Then
        '    MsgBox("Bit Mode Failed")
        'End If

        Button2.Enabled = True


    End Sub
#End Region

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim dev_select As Int16 = ComboBox1.SelectedIndex


        FT_Status = FT_OpenByIndex(dev_select, FT_Handle)
        If FT_Status <> FT_OK Then
            MsgBox("Failed to open device.", , )
            Exit Sub
        End If
        FT_Status = FT_Purge(FT_Handle, FT_PURGE_RX Or FT_PURGE_TX)
        If FT_Status <> FT_OK Then
            MsgBox("Failed to open device.", , )
            Exit Sub
        End If

        FT_Status = FT_SetBitMode(FT_Handle, &H0, FT_ASYNCHRONOUS_BIT_BANG)
        If Not FT_Status = FT_OK Then
            MsgBox("Bit Mode Failed")
        End If


        Button2.Enabled = False
        Button1.Enabled = False
        Timer1.Enabled = True

    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick


        FT_Status = FT_GetBitMode(FT_Handle, BytesWritten)

        If FT_Status <> FT_OK Then
            MsgBox("Read Failed")
            Exit Sub
        Else
            Show_Input(BytesWritten)
        End If

    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        FT_Status = FT_SetBitMode(FT_Handle, &H0, FT_RESET_BITMODE)
        If Not FT_Status = FT_OK Then
            MsgBox("Bit Mode Failed")
        End If
    End Sub

    Private Sub Show_Input(ByVal b As Byte)
        Dim signal_1, signal_2 As Byte
        'Label4.Text = BytesWritten
        'Data 0
        signal_1 = BytesWritten And &H1
        'Data 1
        signal_2 = BytesWritten And &H2


        RadioButton1.Checked = signal_1
        RadioButton2.Checked = signal_2

    End Sub

    
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        FT_Status = FT_SetBitMode(FT_Handle, &H0, FT_RESET_BITMODE)
        If Not FT_Status = FT_OK Then
            MsgBox("Bit Mode Failed")
        End If
        Me.Close()
    End Sub
End Class
